* ErRor - textmode intro
* coded by pr0be
* 25/02/2004
*
* gouraud.asm - gouraud cube

nrx	equ $90
nry	equ $98
tx	equ $a0
ty	equ $a8
tc	equ $b0
xinc	equ $b9
yinc	equ $ba
xn	equ $bb
yn	equ $bc
zn	equ $bd
katx	equ $be
katy	equ $bf
count3	equ $c4

edge0	equ $5328
edge1	equ $5428
edge2	equ $5528
edge3	equ $5628
mul23lo	equ $5728
mul23hi	equ $5828
shade	equ $5928
divtab	equ $4600

	org $86d0

* generate divtab
gouraud	lda #<divtab
	sta $f8
	lda #>divtab
	sta $f9
	lda #$00
	sta ext
	sta count3

_gdiv2	ldy #$00
	tya
	sta ($f8),y
	iny
_gdiv	lda count3
	asl @
	asl @
	asl @
	sty tmp2
	jsr div
	tya
	ldy tmp2
	sta ($f8),y
	iny
	cpy #23
	bne _gdiv
	lda $f8
	clc
	adc #23
	bcc *+4
	inc $f9
	sta $f8
	inc count3
	lda #21
	cmp count3
	bne _gdiv2
	lda #$02
	sta divtab+$86
	lda #$05
	sta divtab+$10c
	lda #$0c
	sta divtab+$192

	ldy #19
_mul23	tya
	tax
	lda #23
	jsr mult
	sta mul23lo,y
	lda ext
	clc
	adc #>divtab
	sta mul23hi,y
	dey
	bne _mul23
	lda #$00
	sta mul23lo,y
	lda #>divtab
	sta mul23hi,y

* generate shade table
	lda #$00
	ldx #$00
_clrsh	sta shade,x
	inx
	cpx #$1c
	bne _clrsh

	lda #$02
_gensht	tay
	lsr @
	sta shade,x
	tya
	clc
	adc #$01
	inx
	cpx #$3c
	bne _gensht

* clear edges
	ldx #23	
clredg	lda #$ff
	sta edge0,x
	lda #$00
	sta edge1,x
	sta edge2,x
	sta edge3,x
	dex
	bpl clredg

* setup
	ldx #<colpala
	ldy #>colpala
	jsr setpal
	lda #$c4
	sta cc
	lda #$01
	sta cc2
	lda #$fe
	sta xinc
	lda #$ff
	sta yinc

* main
docube	jsr clrscr

	ldx #$00
* x axis rotation
cloop	ldy katx
	lda pz,x
	jsr calcsin	* pz * sin(katx)
	sta tmp
	lda py,x
	jsr calccos	* py * cos(katx)
	sec
	sbc tmp
	sta yn		* yn = py*cos(katx)-pz*sin(katx)

	lda py,x
	jsr calcsin	* py*sin(katx)
	sta tmp
	lda pz,x
	jsr calccos	* pz*cos(katx)
	clc
	adc tmp
	sta tmp		* tmp = pz*cos(katx)+py*sin(katx)

* y axis rotation
	ldy katy
	lda sintab,y
	ldy tmp
	jsr fmul
	sta tmp2	* tmp*sin(katy)
	ldy katy
	lda px,x
	jsr calccos	* px*cos(katy)
	clc
	adc tmp2
	sta xn		* xn=px*cos(katy)+tmp*sin(katy)

	lda px,x
	jsr calcsin	* px*sin(katy)
	sta tmp2
	lda costab,y
	ldy tmp
	jsr fmul	* tmp*cos(katy)
	sec
	sbc tmp2	* A=tmp*cos(katy)-px*sin(katy)	

* transformation
	bpl _tr1
	eor #$ff
	clc
	adc #$01
	lsr @
	eor #$ff
	clc
	adc #$01
	jmp _tr1+1
_tr1	lsr @
	clc
	adc #$20
	sta zn		* zn = 32 + (zn/2)

	tay
	lda ztab,y
	ldy xn
	jsr fmul
	bpl _tr2
	eor #$ff
	clc
	adc #$01
	lsr @
	lsr @
	tay
	eor #$ff
	clc
	adc #$01
	sta nrx,x	* save for normal calc
	tya
	lsr @
	eor #$ff
	clc
	adc #$01
	jmp _tr2+6
_tr2	lsr @
	lsr @
	sta nrx,x	* save for normal calc
	lsr @

	clc
	adc #20
	sta tx,x	* tx=20+((xn*ztab)/8)

	ldy zn
	lda ztab,y
	ldy yn
	jsr fmul
	bpl _tr3
	eor #$ff
	clc
	adc #$01
	lsr @
	lsr @
	tay
	eor #$ff
	clc
	adc #$01
	sta nry,x	* save for normal calc
	tya
	lsr @
	eor #$ff
	clc
	adc #$01
	jmp _tr3+6
_tr3	lsr @
	lsr @
	sta nry,x	* save for normal calc
	lsr @

	clc
	adc #12
	sta ty,x	* ty=12+((yn*ztab)/8)

	ldy zn
	lda shade,y
	sta tc,x

	inx
	cpx #$08
	beq _incang
	jmp cloop

_incang nop
	lda katx
	clc
	adc xinc
	sta katx
	lda katy
	clc
	adc yinc
	sta katy

* draw poly
	lda nrx+0
	sec
	sbc nrx+2
	tay
	lda nry+1
	sec
	sbc nry+0
	jsr fmul
	sta tmp
	lda nry+0
	sec
	sbc nry+2
        tay
	lda nrx+1
	sec
	sbc nrx+0
	jsr fmul
	sec
	sbc tmp
	bpl _nrels1

	lda nrx+5
	sec
	sbc nrx+7
	tay
	lda nry+4
	sec
	sbc nry+5
	jsr fmul
	sta tmp
	lda nry+5
	sec
	sbc nry+7
        tay
	lda nrx+4
	sec
	sbc nrx+5
	jsr fmul
	sec
	sbc tmp
	bmi _nrm2

	lda tx+4
	sta x1
	lda ty+4
	sta y1
	lda tc+4
	sta c1
	lda tx+5
	sta x2
	lda ty+5
	sta y2
	lda tc+5
	sta c2
	lda tx+6
	sta x3
	lda ty+6
	sta y3
	lda tc+6
	sta c3
	ldx tx+7
	ldy ty+7
	lda tc+7
	jsr sqrpoly

	jmp _nrm2

_nrels1	lda tx+0
	sta x1
	lda ty+0
	sta y1
	lda tc+0
	sta c1
	lda tx+1
	sta x2
	lda ty+1
	sta y2
	lda tc+1
	sta c2
	lda tx+2
	sta x3
	lda ty+2
	sta y3
	lda tc+2
	sta c3
	ldx tx+3
	ldy ty+3
	lda tc+3
	jsr sqrpoly

_nrm2	lda nrx+1
	sec
	sbc nrx+6
	tay
	lda nry+5
	sec
	sbc nry+1
	jsr fmul
	sta tmp
	lda nry+1
	sec
	sbc nry+6
        tay
	lda nrx+5
	sec
	sbc nrx+1
	jsr fmul
	sec
	sbc tmp
	bpl _nrels2

	lda nrx+4
	sec
	sbc nrx+3
	tay
	lda nry+0
	sec
	sbc nry+4
	jsr fmul
	sta tmp
	lda nry+4
	sec
	sbc nry+3
        tay
	lda nrx+0
	sec
	sbc nrx+4
	jsr fmul
	sec
	sbc tmp
	bmi _nrm3

	lda tx+0
	sta x1
	lda ty+0
	sta y1
	lda tc+0
	sta c1
	lda tx+4
	sta x2
	lda ty+4
	sta y2
	lda tc+4
	sta c2
	lda tx+7
	sta x3
	lda ty+7
	sta y3
	lda tc+7
	sta c3
	ldx tx+3
	ldy ty+3
	lda tc+3
	jsr sqrpoly
	jmp _nrm3

_nrels2	lda tx+1
	sta x1
	lda ty+1
	sta y1
	lda tc+1
	sta c1
	lda tx+5
	sta x2
	lda ty+5
	sta y2
	lda tc+5
	sta c2
	lda tx+6
	sta x3
	lda ty+6
	sta y3
	lda tc+6
	sta c3
	ldx tx+2
	ldy ty+2
	lda tc+2
	jsr sqrpoly

_nrm3	lda nrx+3
	sec
	sbc nrx+6
	tay
	lda nry+2
	sec
	sbc nry+3
	jsr fmul
	sta tmp
	lda nry+3
	sec
	sbc nry+6
        tay
	lda nrx+2
	sec
	sbc nrx+3
	jsr fmul
	sec
	sbc tmp
	bpl _nrels3

	lda nrx+4
	sec
	sbc nrx+1
	tay
	lda nry+5
	sec
	sbc nry+4
	jsr fmul
	sta tmp
	lda nry+4
	sec
	sbc nry+1
        tay
	lda nrx+5
	sec
	sbc nrx+4
	jsr fmul
	sec
	sbc tmp
	bmi _flpscr

	lda tx+0
	sta x1
	lda ty+0
	sta y1
	lda tc+0
	sta c1
	lda tx+1
	sta x2
	lda ty+1
	sta y2
	lda tc+1
	sta c2
	lda tx+5
	sta x3
	lda ty+5
	sta y3
	lda tc+5
	sta c3
	ldx tx+4
	ldy ty+4
	lda tc+4
	jsr sqrpoly
	jmp _flpscr

_nrels3	lda tx+3
	sta x1
	lda ty+3
	sta y1
	lda tc+3
	sta c1
	lda tx+2
	sta x2
	lda ty+2
	sta y2
	lda tc+2
	sta c2
	lda tx+6
	sta x3
	lda ty+6
	sta y3
	lda tc+6
	sta c3
	ldx tx+7
	ldy ty+7
	lda tc+7
	jsr sqrpoly

_flpscr	jsr flpscr

	dec cc
	bne _main
	dec cc+1
	bne _main
	lda xinc
	cmp #$04
	beq _exit
	lda #$04
	sta xinc
	lda #$02
	sta yinc
	lda #$cb
	sta cc
	lda #$01
	sta cc2
	ldx #<colpalb
	ldy #>colpalb
	jsr setpal
	lda #$90
	sta 712

_main	jmp docube

_exit	jmp rtplsm

* gouraud square poly
dc	equ $80
x1	equ $81
x2	equ $82
x3	equ $83
x4	equ $84
y1	equ $85
y2	equ $86
y3	equ $87
y4	equ $88
c1	equ $89
c2	equ $8a
c3	equ $8b
c4	equ $8c
sx1	equ $8d
sx2	equ $8e
sy1	equ $8f
sy2	equ $c5
sc1	equ $c6
sc2	equ $c7
x	equ $c8
xchg	equ $c9
cl	equ $ca
cchg	equ $f6

* scanedge (X, Y, A, sx2, sy2, sc2)
scanedg	sta sc1
	stx sx1
	sty sy1
	cpy sy2
	bne *+3
	rts
	bcc _sorty
	ldy sx1
	lda sx2
	sta sx1
	sty sx2
	ldy sy1
	lda sy2
	sta sy1
	sty sy2
	ldy sc1
	lda sc2
	sta sc1
	sty sc2
_sorty	lda sy2
	sec
	sbc sy1
	tay
	lda sx2
	sec
	sbc sx1
	tax
	jsr fdiv
	sta xchg	* xchg=(sx2-sx1)/(sy2-sy1)
	lda sc2
	sec
	sbc sc1
	tax
	jsr fdiv
	sta cchg	* cchg=(sc2-sc1)/(sy2-sy1)

	lda sx1
	asl @
	asl @
	asl @
	sta x
	lda sc1
	asl @
	asl @
	asl @
	tay
	ldx sy1

_scan	lda x
	cmp edge0,x
	bcs _chkmax
	sta edge0,x
	tya
	sta edge2,x
	lda x
_chkmax	cmp edge1,x
	bcc _nxtp
	sta edge1,x
	tya
	sta edge3,x
	lda x
_nxtp	clc
	adc xchg
	sta x
	tya
	clc
	adc cchg
	tay
	inx
	cpx sy2
	bne _scan

	rts

* gouraud square poly
sqrpoly	stx x4
	sty y4
	sta c4

	lda x2
	sta sx2
	lda y2
	sta sy2
	lda c2
	sta sc2
	ldx x1
	ldy y1
	lda c1
	jsr scanedg

	lda x3
	sta sx2
	lda y3
	sta sy2
	lda c3
	sta sc2
	ldx x2
	ldy y2
	lda c2
	jsr scanedg	

	lda x4
	sta sx2
	lda y4
	sta sy2
	lda c4
	sta sc2
	ldx x3
	ldy y3
	lda c3
	jsr scanedg

	lda x1
	sta sx2
	lda y1
	sta sy2
	lda c1
	sta sc2
	ldx x4
	ldy y4
	lda c4
	jsr scanedg

	ldx #$00
_drwply	lda edge0,x
	cmp #$ff
	beq _nxtedg
	lda edge2,x
	lsr @
	lsr @
	lsr @
	sta c1
	lda edge3,x
	lsr @
	lsr @
	lsr @
	sta c2
	lda edge0,x
	lsr @
	lsr @
	lsr @
	tay
	lda edge1,x
	lsr @
	lsr @
	lsr @
	jsr hline
	lda #$ff
	sta edge0,x
	lda #$00
	sta edge1,x
_nxtedg	inx
	cpx #24
	bne _drwply

	rts

* hline	(Y, A, c1, c2, X)
hline	sty x1
	stx tmp
	sta x2
	cmp x1
	bne *+3
	rts
	lda x2
	sec
	sbc x1
	tay
	lda c2
	sec
	sbc c1
	tax
	jsr fdiv
	sta dc		* dc=(c2-c1)/(x2-x1)
	jmp _hln

_hln	lda tmp
	clc
	adc screen
	sta $fb

	ldy x1
	lda c1
	asl @
	asl @
	asl @
_drwhln	sta tmp2
	lsr @
	lsr @
	lsr @
	tax
	lda coltab,x
	sta ($fa),y
	lda tmp2
	clc
	adc dc
	iny
	cpy x2
	bcc _drwhln

	ldx tmp
	rts

* calc sin/cos
calcsin	bmi _csin
	lda sintab,y
	rts
_csin	lda sintab,y
	eor #$ff
	clc
	adc #$01
	rts

calccos	bmi _ccos
	lda costab,y
	rts
_ccos	lda costab,y
	eor #$ff
	clc
	adc #$01
	rts

* div ext,a/y->y
div	sty tmp
	ldy #$00
divv	sec
	sbc tmp
	bcs *+6
	dec ext
	bmi _div
	iny
	jmp divv
_div	rts

* fastdiv x/y->a
fdiv	bmi _divsg
	lda mul23hi,x
	sta $f9
	lda mul23lo,x
	sta $f8
	lda ($f8),y
	rts
_divsg	txa
	eor #$ff
	clc
	adc #$01
	tax
	lda mul23hi,x
	sta $f9
	lda mul23lo,x
	sta $f8
	lda ($f8),y
	eor #$ff
	clc
	adc #$01
	rts
*

colpala	dta $96,$9a,$94,$0f
colpalb	dta $36,$3a,$34,$1f

px	dta $ff,$01,$01,$ff,$ff,$01,$01,$ff
py	dta $ff,$ff,$01,$01,$ff,$ff,$01,$01
pz	dta $ff,$ff,$ff,$ff,$01,$01,$01,$01

	org $5228
ztab	ins "ztab.dat"
